<?php

namespace App|C\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfFrequentFlyerLevel ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfFrequentFlyerLevel
 * @subpackage Arrays
 */
class ArrayOfFrequentFlyerLevel extends AbstractStructArrayBase
{
    /**
     * The FrequentFlyerLevel
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\FrequentFlyerLevel[]
     */
    public $FrequentFlyerLevel;
    /**
     * Constructor method for ArrayOfFrequentFlyerLevel
     * @uses ArrayOfFrequentFlyerLevel::setFrequentFlyerLevel()
     * @param \App|C\StructType\FrequentFlyerLevel[] $frequentFlyerLevel
     */
    public function __construct(array $frequentFlyerLevel = array())
    {
        $this
            ->setFrequentFlyerLevel($frequentFlyerLevel);
    }
    /**
     * Get FrequentFlyerLevel value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\FrequentFlyerLevel[]|null
     */
    public function getFrequentFlyerLevel()
    {
        return isset($this->FrequentFlyerLevel) ? $this->FrequentFlyerLevel : null;
    }
    /**
     * This method is responsible for validating the values passed to the setFrequentFlyerLevel method
     * This method is willingly generated in order to preserve the one-line inline validation within the setFrequentFlyerLevel method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateFrequentFlyerLevelForArrayConstraintsFromSetFrequentFlyerLevel(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfFrequentFlyerLevelFrequentFlyerLevelItem) {
            // validation for constraint: itemType
            if (!$arrayOfFrequentFlyerLevelFrequentFlyerLevelItem instanceof \App|C\StructType\FrequentFlyerLevel) {
                $invalidValues[] = is_object($arrayOfFrequentFlyerLevelFrequentFlyerLevelItem) ? get_class($arrayOfFrequentFlyerLevelFrequentFlyerLevelItem) : sprintf('%s(%s)', gettype($arrayOfFrequentFlyerLevelFrequentFlyerLevelItem), var_export($arrayOfFrequentFlyerLevelFrequentFlyerLevelItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The FrequentFlyerLevel property can only contain items of type \App|C\StructType\FrequentFlyerLevel, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set FrequentFlyerLevel value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \App|C\StructType\FrequentFlyerLevel[] $frequentFlyerLevel
     * @return \App|C\ArrayType\ArrayOfFrequentFlyerLevel
     */
    public function setFrequentFlyerLevel(array $frequentFlyerLevel = array())
    {
        // validation for constraint: array
        if ('' !== ($frequentFlyerLevelArrayErrorMessage = self::validateFrequentFlyerLevelForArrayConstraintsFromSetFrequentFlyerLevel($frequentFlyerLevel))) {
            throw new \InvalidArgumentException($frequentFlyerLevelArrayErrorMessage, __LINE__);
        }
        if (is_null($frequentFlyerLevel) || (is_array($frequentFlyerLevel) && empty($frequentFlyerLevel))) {
            unset($this->FrequentFlyerLevel);
        } else {
            $this->FrequentFlyerLevel = $frequentFlyerLevel;
        }
        return $this;
    }
    /**
     * Add item to FrequentFlyerLevel value
     * @throws \InvalidArgumentException
     * @param \App|C\StructType\FrequentFlyerLevel $item
     * @return \App|C\ArrayType\ArrayOfFrequentFlyerLevel
     */
    public function addToFrequentFlyerLevel(\App|C\StructType\FrequentFlyerLevel $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \App|C\StructType\FrequentFlyerLevel) {
            throw new \InvalidArgumentException(sprintf('The FrequentFlyerLevel property can only contain items of type \App|C\StructType\FrequentFlyerLevel, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->FrequentFlyerLevel[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \App|C\StructType\FrequentFlyerLevel|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \App|C\StructType\FrequentFlyerLevel|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \App|C\StructType\FrequentFlyerLevel|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \App|C\StructType\FrequentFlyerLevel|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \App|C\StructType\FrequentFlyerLevel|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string FrequentFlyerLevel
     */
    public function getAttributeName()
    {
        return 'FrequentFlyerLevel';
    }
}
